



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>GP开发示例：数据库去重</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">GP开发示例：数据库去重</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 20:04:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>这个例子专业讲解基于ArcEngine使用GP开发的过程及遇到的问题。更多GP使用方法：<a href="http://www.cnblogs.com/liweis/p/4155941.html" rel="external nofollow noreferrer">GP使用心得</a></p>
<p><strong>功能需求</strong>：现在外业第一次数据（简称调绘.mdb）和第二次数据（简称检查.mdb）有重复。第二次是在第一次的基础上进行的，即如果调绘.mdb中LCA层有365个要素，检查时发现错误，就删除了11个错误，并新增了43个，共408个，检查.mdb相对于调绘.mdb实际上有354个重复，现在要将重复的删除，mdb中包括点、线、面三种类型的要素类。</p>
<p><strong>软件实现</strong>：在ArcGIS里利用工具可以实现，使用按空间位置查询，找出重复的，然后删除即可；由于每个mdb中的要素图层比较多，所以可以使用批处理，批处理时填写参数可以<a href="http://www.cnblogs.com/liweis/p/4193811.html" rel="external nofollow noreferrer">利用Excel快速进行</a>。但是，mdb较多，路径各不相同，图层较多，操作起不比较费时。</p>
<p><strong>程序实现</strong>：</p>
<p>1.首先确定用什么工具来实现（先在ArcGIS里做一次）：利用空间位置查询选择重复的要素，开启编辑器，删除！</p>
<p>2.设计界面，我每写一个功能，都要把界面整理一下，因为我不想让它很丑就出去见人。这里使用DotNetBar，节省了相当多的时间。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/388559/201501/091245512345939.png"></p>
<p>3.因为是直接对数据库进行操作，所以首先就要遍历数据中的要素图层，一般做法是利用GP的ListFeatureClasses方法。</p>
<pre class="prettyprint linenums">GP.SetEnvironmentValue("workspace", moreDBPath.Trim());<br />
IGpEnumList pGpEnumList = GP.ListFeatureClasses("", "", "");<br />
string strFC = pGpEnumList.Next();<br />
while (strFC != "")<br />
{<br />
    System.Windows.Forms.Application.DoEvents();<br />
    Console.WriteLine(strFC);<br />
    strFC = pGpEnumList.Next();<br />
}</pre>
<p>选择遍历数据库没有问题！</p>
<p>4.利用按位置选择</p>
<pre class="prettyprint linenums">SelectLayerByLocation SLBL = new SelectLayerByLocation();<br />
SLBL.in_layer = moreDB + "\\" + strFC;<br />
SLBL.select_features = referDB + "\\" + strFC;<br />
SLBL.overlap_type = "ARE_IDENTICAL_TO";<br />
GPClass.Execute(SLBL); //这里使用了自定义的GPClass类，可以直接使用GPExecute</pre>
<p>报错ERROR 000368，去官网帮助一查，竟然没有368，这是为什么？但从相邻错误信息来看，应该是哪个参数无效！</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/388559/201501/091246083125755.png"></p>
<p>再去官网看了按空间位置查询的帮助文档。它说：输入必须是要素图层；不可以是要素类。要素图层？要素类？以前一直把它们看成是一种意思，于是去查一下了帮助，长知识了。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/388559/201501/091632217348031.png"></p>
<p>结果Python的示例代码，使用了MakeFeatureLayer来创建要素图层。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/388559/201501/091632325314667.png"></p>
<pre class="prettyprint linenums">//创建要素图层<br />
MakeFeatureLayer MFL = new MakeFeatureLayer();<br />
MFL.in_features = moreDB + "\\" + strFC;<br />
MFL.out_layer = strFC + @"_Lyr";<br />
GPClass.Execute(MFL);

//按位置选择<br />
SelectLayerByLocation SLBL = new SelectLayerByLocation();<br />
SLBL.in_layer = strFC + @"_Lyr";<br />
SLBL.select_features = referDB + "\\" + strFC;<br />
SLBL.overlap_type = "ARE_IDENTICAL_TO";<br />
GPClass.Execute(SLBL);</pre>
<p>GP执行成功，虽然还看不到效果。因为MakeFeatureLayer是临时图层，程序结束就没有了，需要将它导出来：</p>
<pre class="prettyprint linenums">//复制要素导出</pre>
<pre class="prettyprint linenums">CopyFeatures CF = new CopyFeatures();<br />
CF.in_features = strFC + @"_Lyr";<br />
CF.out_feature_class = resultDB + "\\" + strFC;<br />
GPClass.Execute(CF);</pre>
<p>现在的问题是是选择类型是ARE_IDENTICAL_TO，如果输入图层中的要素与某一选择要素相同（就几何而言），则会选择这些要素。生成的mdb是重复那一部分，而需要的结果是不重复的那一部分。在ArcGIS里可以通过切换选择来操作。于是想，先把它全部选中，然后将重复的移除。代码：</p>
<pre class="prettyprint linenums">//创建要素图层<br />
MakeFeatureLayer MFL = new MakeFeatureLayer();<br />
MFL.in_features = moreDB + "\\" + strFC;<br />
MFL.out_layer = strFC + @"_Lyr";<br />
GPClass.Execute(MFL);

//选择所有<br />
SelectLayerByAttribute SLBA = new SelectLayerByAttribute();<br />
SLBA.in_layer_or_view = strFC + @"_Lyr";<br />
GPClass.Execute(SLBA);

//按位置选择（移除）<br />
SelectLayerByLocation SLBL = new SelectLayerByLocation();<br />
SLBL.in_layer = strFC + @"_Lyr";<br />
SLBL.select_features = referDB + "\\" + strFC;<br />
SLBL.overlap_type = "ARE_IDENTICAL_TO";<br />
SLBL.selection_type = "REMOVE_FROM_SELECTION";<br />
GPClass.Execute(SLBL);

//复制要素<br />
CopyFeatures CF = new CopyFeatures();<br />
CF.in_features = strFC + @"_Lyr";<br />
CF.out_feature_class = resultDB + "\\" + strFC;<br />
GPClass.Execute(CF);</pre>
<p>终于实现了。</p>
<p>5.为了增加用户的体验，重写在了一个类，并把新建一个线程来处理：</p>
<pre class="prettyprint linenums">string referDB = "";<br />
string moreDB = "";<br />
string resultDB = "";<br />
ProgressBarX progress = null;<br />
public NoRepeatClass(string _referDB, string _moreDB, string _resultDB, ProgressBarX _progress)<br />
{<br />
    referDB = _referDB;<br />
    moreDB = _moreDB;<br />
    resultDB = _resultDB;<br />
    progress = _progress;

    Thread MyThreadOne = new Thread(new ThreadStart(MainFun));<br />
    MyThreadOne.Name = "NoRepeat";<br />
    MyThreadOne.IsBackground = true;<br />
    MyThreadOne.Start();<br />
}

private void MainFun()<br />
{<br />
 //主程序代码<br />
｝</pre>
<p>6.为了让用户知道处理的进度，于是添加了进度条，并更新内容为当前处理图层的名称。但这里，不能直接在一个线程里设置主线程的控件属性，于是找了一个函数：</p>
<pre class="prettyprint linenums">#region 设置控件参数<br />
/// &lt;summary&gt;<br />
/// 设置控件参数<br />
/// &lt;/summary&gt;<br />
/// &lt;param name="oControl"&gt;控件&lt;/param&gt;<br />
/// &lt;param name="propName"&gt;参数名称&lt;/param&gt;<br />
/// &lt;param name="propValue"&gt;参数值&lt;/param&gt;<br />
delegate void SetControlValueCallback(Control oControl, string propName, object propValue);<br />
public static  void SetControlPropertyValue(Control oControl, string propName, object propValue)<br />
{<br />
    if (oControl.InvokeRequired)<br />
    {<br />
        SetControlValueCallback d = new SetControlValueCallback(SetControlPropertyValue);<br />
        oControl.Invoke(d, new object[] { oControl, propName, propValue });<br />
    }<br />
    else<br />
    {<br />
        Type t = oControl.GetType();<br />
        System.Reflection.PropertyInfo[] props = t.GetProperties();<br />
        foreach (System.Reflection.PropertyInfo p in props)<br />
        {<br />
            if (p.Name.ToUpper() == propName.ToUpper())<br />
            {<br />
                p.SetValue(oControl, propValue, null);<br />
            }<br />
        }<br />
    }<br />
}<br />
#endregion</pre>
<p>目前的效果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/388559/201501/091632396715718.png"></p>
<p>7.为了提高操作效率，增加了路径拖放功能，下面是拖放类：</p>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Text;<br />
using System.Windows.Forms;<br />
using System.IO;

namespace GPTools<br />
{<br />
    class DragClass<br />
    {<br />
        private  Control control;<br />
        private string fileType = "";

        public DragClass(Control _control,string _fileType)<br />
        {<br />
            //如果控件为空<br />
            if (_control == null)<br />
            {<br />
                return;<br />
            }<br />
            control = _control;<br />
            fileType = _fileType;

            //设置是否可以拖放<br />
            control.AllowDrop = true;

            //定义拖放事件<br />
            control.DragEnter += new DragEventHandler(control_DragEnter);<br />
          ontrol.DragDrop += new DragEventHandler(control_DragDrop);

        }

        private void control_DragEnter(object sender, DragEventArgs e)<br />
        {<br />
            if (e.Data.GetDataPresent(DataFormats.FileDrop))<br />
            {<br />
                e.Effect = DragDropEffects.Copy;<br />
            }<br />
        }

        private void control_DragDrop(object sender, DragEventArgs e)<br />
        {<br />
            string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);<br />
            foreach (string file in files)<br />
            {<br />
                //判断文件类型<br />
                if (Path.GetExtension(file) == fileType)<br />
                {<br />
                    Console.WriteLine(file);<br />
                    control.Text = file;<br />
                }<br />
            }<br />
        }<br />
    }<br />
}
</pre>
<p>在初始化主程序后实例化拖放类，一旦拖放就会触发DragEnter事件和DragDrop事件：</p>
<pre class="prettyprint linenums">DragClass dg = new DragClass(this.txbReferDB, ".mdb");<br />
DragClass dg2 = new DragClass(this.txbMoreDB, ".mdb");</pre>
<p>8.因为我们只遍历了检查.mdb中的图层，万一调绘.mdb中没有对应图层怎么，所以，我们得检查，如果没有则跳过。</p>
<pre class="prettyprint linenums">//创建要素图层<br />
//……

//检查数据<br />
object dt = "";<br />
if (GPClass.GP.Exists(referDB + "\\" + strFC, ref dt))<br />
{<br />
    //3.选择所有<br />
    //4.按位置选择（移除）<br />
}<br />
//复制要素<br />
//……</pre>
<p>9.为了更准确的统计操作时间，添加了计时功能。效果图如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/388559/201501/091632470627927.png"></p>
<p>10.为了让用户快速进行执行任务，可以在执行按钮上添加Enter事件。</p>
<pre class="prettyprint linenums">private void btnExcute_Enter(object sender, EventArgs e)<br />
{<br />
    Excute();<br />
}

private void Excute()<br />
{<br />
    referDBPath = txbReferDB.Text.Trim();<br />
    moreDBPath = txbMoreDB.Text.Trim();<br />
    resultDBPath = txbResultDB.Text.Trim();

    if (referDBPath.Trim() != "" &amp;&amp; moreDBPath.Trim() != "" &amp;&amp; resultDBPath.Trim() != "")<br />
    {<br />
        NoRepeatClass nr = new NoRepeatClass(referDBPath, moreDBPath, resultDBPath, progressBar);<br />
    }<br />
    else<br />
    {<br />
        MessageBoxEx.EnableGlass = false;<br />
        MessageBoxEx.Show("警告：数据库路径选择有误！\n    请检查数据路径是否正确。", "提示");<br />
    }<br />
}</pre>
<p>参考：<a href="http://bbs.esrichina-bj.cn/esri/viewthread.php?tid=50540" rel="external nofollow noreferrer">http://bbs.esrichina-bj.cn/esri/viewthread.php?tid=50540</a></p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwvzv38.html">深入理解客户区尺寸client</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn4ylg8.html">阅读《LEARNING HARD C&num;学习笔记》知识点总结与摘要三</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gx104q.html">hybrid app</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd7kxvq.html">&lbrack;CLK Framework&rsqb; CLK&period;Threading&period;PortableTimer - 跨平台的Timer类别</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2r1lo9.html">Android下拉刷新完全解析，教你如何一分钟实现下拉刷新功能 （转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv5gkjq.html">DEV界面皮肤</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1mz6j9.html">Delphi 调试日子 - 莫名其妙的堆溢出</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnvjwrq.html">OC - 1&period;面向过程和面向对象的思想对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydzl4xq.html">SGU 294 He&amp;&num;39&semi;s Circles</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzx5zg8.html">JS 对象API之获取原型对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojep01q.html">JSON&period;stringify的三个参数&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meg04rq.html">详解HTTPS、TLS、SSL</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjdvre9.html">（1）&period;NET CORE微服务 Micro-Service ---- 什么是微服务架构，&period;netCore微服务选型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2jd2z9.html">禁用cookie后的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2wvey9.html">Android四大组件之&mdash;&mdash;Activity&lpar;一&rpar;定义、状态和后退栈&lpar;图文详解&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/960rgyj9.html">centos 安装 和 linux 简单命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rgpkm9.html">express依赖中模块引擎的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/96303nj9.html">urlretrieve关于循环下载的一个案例</a>
		</li>
						<li><a href="https://www.batexi.com/a/902d463q.html">php curl-class post</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pk0mg8.html">详解Spring Boot集成MyBatis的开发流程</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2kvgplq.html">安装第三方jar包的两种方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qven3rz9.html">Shell 学习笔记之函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/953y7we8.html">Minimum Size Subarray Sum 最短子数组之和</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql17pwk9.html">洛谷P2746 USACO5&period;1 校园网</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kvy63q.html">【转载】实现UTF8与GB2312编码格式相互转换&lpar;VC&rpar;已经验证！</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pw3x5q.html">SGU 403 Scientific Problem</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvennxy9.html">Unity3D中的UnitySendMessage方法的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkx7118.html">OPC Server开发的几大境界</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pwo6eq.html">myql --- mysqldump使用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnmxg4q.html">常用的快速Web原型图设计工具</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
